<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <function>Task 800 - Ôn thi giữa kỳ</function>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/LinhLT.jpeg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="department.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Department CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="employee.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Employee CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Department - Employee CRUD</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quản trị Phòng ban</h2>
        <div class="jumbotron container">
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="code">Mã department</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-code" name="code" placeholder="Department code"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="name">Tên department</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-name" name="name" placeholder="Department name" class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="function">Nghiệp vụ</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-function" name="function" placeholder="Function" class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="introduction">Giới thiệu</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-introduction" name="introduction" placeholder="Introduction" class="form-control">
          </div>
          </div>
          <div class="row pull-right">
          <div class="col-sm-3">
          </div>
          <div class="col-sm-9">
            <div class ="row">
              <div class="col-sm-3">
                <button id="btn-update-department" class="btn btn-info w-100"><i class="fas fa-edit"></i>&nbsp;Update</button>
              </div>
              <div class="col-sm-3">
                <button id="btn-delete-department" class="btn btn-danger w-100"><i class="fas fa-trash"></i>&nbsp;Delete</button>
              </div>
              <div class="col-sm-3">
                <button id="btn-create-department" class="btn btn-success w-100"><i class="fa fa-plus"></i>&nbsp;Add New</button>
              </div>
              <div class = "col-sm-3">
                <button id="btn-cancel" class="btn btn-secondary w-100">Cancel</button>
              </div>
            </div>
          </div>
          
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="department-table">
          <thead>
            <tr>
              <th>Id</th>
              <th>Mã phòng ban</th>
              <th>Tên phòng ban</th>
              <th>Nghiệp vụ</th>
              <th>Giới thiệu</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-function" id="h5-modal-function">Xác nhận xóa department</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa department này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete">Xác nhận</button>
            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id department đang đc update or delete. Mặc định = 0;
var gDepartmentId = 0;
const gBASE_URL = "http://localhost:8080/department";
const gCONTENT_TYPE = "application/json;charset=UTF-8";
var gDepartmentArr = [];
$(document).ready(function(){
	var table = $("#department-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"code"},
			{"data":"name"},
			{"data":"function"},
			{"data":"introduction"},
		]
	})
	$.ajax({
		url: gBASE_URL + "/all",
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
      gDepartmentArr = res;
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.responseText);
		}
	})
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#department-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update department: add event to save data button
	$("#btn-update-department").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new department
	$("#btn-create-department").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete department selected
	$("#btn-delete-department").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Cancel
	$("#btn-cancel").on("click",function(){
		onCancelBtnClick();
	});
  //gán sự kiện cho nút xác nhận xóa data trên modal
  $("#btn-confirm-delete").on("click",function(){
    onBtnConfirmDeleteDepartmentClick();
  });
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gDepartmentId = $(paramRow).find("td:eq(0)").html();
		console.log("Department id of selected row: " + gDepartmentId);
		//lấy thông tin department của row được click và hiển thị lên form
		var vDepartment = callApiGetDepartmentById(gDepartmentId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo department obj
		var vDepartmentObj = {
			code: "",
			name: "",
			function:"",
      introduction: ""
		}
		// B1: Thu thập dữ liệu
		getUpdateDepartmentData(vDepartmentObj);
		// B2: Validate update
		var vIsDepartmentValid = validateDepartmentData(vDepartmentObj);
    	if (vIsDepartmentValid){
			// B3: update department
			$.ajax({
				url: gBASE_URL +"/update/"+ gDepartmentId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDepartmentObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateDepartmentSuccess();
				},
				error: function(err){
					alert(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm department
	function onCreateButtonClick(){
		//khai báo department obj
		var vDepartmentObj = {
			code: "",
			name: "",
			function:"",
      introduction: ""
		}
		// B1: Thu thập dữ liệu
		getUpdateDepartmentData(vDepartmentObj);
		// B2: Validate data
		var vIsDepartmentValid = validateDepartmentData(vDepartmentObj);
    	if (vIsDepartmentValid){
			// B3: create department
			$.ajax({
				url: gBASE_URL + "/create",
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDepartmentObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleintroductionepartmentSuccess();
				},
				error: function(err){
					alert(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa department được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    $("#delete-modal").modal("show");
	}
  //hàm xử lý sự kiện xác nhận xóa department
  function onBtnConfirmDeleteDepartmentClick(){
    "use strict";
    //gọi API xóa department
    ajaxDeleteDepartment(gDepartmentId);
  }
  
	function onCancelBtnClick(){
    $("#input-code").val("");
		$("#input-name").val(""); 
		$("#input-function").val(""); 
		$("#input-introduction").val(""); 
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	//hàm load lại datatable
  function loadDataToTable(){
    $.ajax({
      url: gBASE_URL + "/all",
      type: "GET",
      dataType: "json",
      success: function(res){
        console.log(res);
        gDepartmentArr = res;
        table.clear();
        table.rows.add(res);
        table.draw();
      },
      error: function(err){
        console.log(err.responseText);
      }
    })
  }
  
  //hàm gọi API lấy thông tin department của dòng được chọn
	function callApiGetDepartmentById(paramId){
		$.ajax({
			url: gBASE_URL +"/detail/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayDepartmentData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin department của dòng được click
	function displayDepartmentData(paramDepartment){
		$("#input-code").val(paramDepartment.code);
		$("#input-name").val(paramDepartment.name); 
		$("#input-function").val(paramDepartment.function); 
		$("#input-introduction").val(paramDepartment.introduction); 
	}
	// hàm thu thập dữ liệu để update department
	function getUpdateDepartmentData(paramDepartmentObj) {
		paramDepartmentObj.code =$("#input-code").val().trim();
		paramDepartmentObj.name = $("#input-name").val(); 
		paramDepartmentObj.function = $("#input-function").val().trim();
    paramDepartmentObj.introduction = $("#input-introduction").val().trim(); 
	}

	// hàm validate data
	function validateDepartmentData(paramDepartmentObj) {
		if (paramDepartmentObj.code === "") {
      alert("Cần nhập mã department");
      return false;
		}
    
		if (paramDepartmentObj.name === "") {
      alert("Cần nhập tên department");
      return false;
		}
		if (paramDepartmentObj.function === "") {
      alert("Cần nhập mô tả department");
      return false;
		}

		return true;
	}
	
	//hiển thị cập nhật department thành công
	function handleUpdateDepartmentSuccess(){
		alert("Sửa department có id: " + gDepartmentId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm department thành công
	function handleintroductionepartmentSuccess(){
		alert("Thêm department thành công!");
    loadDataToTable();
	};
  //API xóa department
  function ajaxDeleteDepartment(paramId){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
    $.ajax({
      url: gBASE_URL +"/delete/"+ paramId,
      type: "DELETE",
      success: function(paramRes) {
        handleDeleteDepartmentSuccess();
      },
      error: function(paramErr) {
        alert("Xóa department không thành công");
      }
    });
  };
  
	//hiển thị xóa department thành công
	function handleDeleteDepartmentSuccess(){
		alert("Xóa department có id: " + gDepartmentId + " thành công!");
    loadDataToTable();
    //ẩn modal
    $("#delete-modal").modal("hide");
	};
})
</script>
</body>
</html>
